From 8fe9efc8e8ea4f89d7ab2c2384b065b7bfe2aba9 Mon Sep 17 00:00:00 2001
From: Luke Leighton <lkcl@lkcl.net>
Date: Mon, 13 Sep 2010 16:43:18 +0100
Subject: [PATCH 21/34] add datetime.time proxy

---
 .../gnumed/client/ProxiedWeb/gui/jsonobjproxy.py   |   13 +++++++++++--
 .../gnumed/client/pycommon/gmBusinessDBObject.py   |   10 ++++++++++
 2 files changed, 21 insertions(+), 2 deletions(-)

diff --git a/gnumed/gnumed/client/ProxiedWeb/gui/jsonobjproxy.py b/gnumed/gnumed/client/ProxiedWeb/gui/jsonobjproxy.py
index 78a0608..befb984 100644
--- a/gnumed/gnumed/client/ProxiedWeb/gui/jsonobjproxy.py
+++ b/gnumed/gnumed/client/ProxiedWeb/gui/jsonobjproxy.py
@@ -1,4 +1,4 @@
-from datetime import timedelta, tzinfo, datetime
+from datetime import timedelta, tzinfo, datetime, time
 
 class Proxy(object):
     def __init__(self, **kwargs):
@@ -8,7 +8,7 @@ class Proxy(object):
 class cDocumentType(Proxy):
     pass
 
-class cPerson(Proxy):
+class cIdentity(Proxy):
     pass
 
 class cMedDoc(Proxy):
@@ -68,6 +68,15 @@ class FixedOffsetTimezone(tzinfo):
         return ZERO
 
 
+class Time(time):
+    def __init__(self, **kwargs):
+        hour = kwargs.get('hour')
+        minute = kwargs.get('minute')
+        second = kwargs.get('second')
+        microsecond = kwargs.get('microsecond')
+        tzinfo = kwargs.get('tzinfo', None)
+        time.__init__(self, hour, minute, second, microsecond, tzinfo)
+
 class DateTime(datetime):
     def __init__(self, **kwargs):
         year = kwargs.get('year')
diff --git a/gnumed/gnumed/client/pycommon/gmBusinessDBObject.py b/gnumed/gnumed/client/pycommon/gmBusinessDBObject.py
index 0ec83bc..c14972c 100644
--- a/gnumed/gnumed/client/pycommon/gmBusinessDBObject.py
+++ b/gnumed/gnumed/client/pycommon/gmBusinessDBObject.py
@@ -478,6 +478,16 @@ def jsonclasshintify(obj):
 		res['seconds'] = obj.seconds
 		res['microseconds'] = obj.microseconds
 		return res
+	elif isinstance(obj, datetime.time):
+		# this will get decoded as "from jsonobjproxy import {clsname}"
+		# at the remote (client) end.
+		res = {'__jsonclass__': ["jsonobjproxy.Time"]}
+		res['hour'] = obj.hour
+		res['minute'] = obj.minute
+		res['second'] = obj.second
+		res['microsecond'] = obj.microsecond
+		res['tzinfo'] = jsonclasshintify(obj.tzinfo)
+		return res
 	elif isinstance(obj, datetime.datetime):
 		# this will get decoded as "from jsonobjproxy import {clsname}"
 		# at the remote (client) end.
-- 
1.7.1

